--[[SirRanjid 2020 https://github.com/SirRanjid]]

function love.mousefocus(f)
	--GAME:CallHook("GameFocusChanged",f)
	if f then
		GAME:CallHook("OnGameFocus")
	else
		GAME:CallHook("OnGameLoseFocus")
	end
end

--release mouse when lost focus
local mousestack = {}
GAME:AddHook("OnGameLoseFocus","KeyDebug",function()
	for k,v in pairs(mousestack) do --release mouse buttons if the game loses focus and a mousebutton was not released
		GAME:CallHook("MouseReleased",0,0,k,nil)
		mousestack[k] = nil
	end
end)

function love.mousepressed(x, y, button, istouch)
	GAME:CallHook("MousePressed",x,y,button,istouch)
	mousestack[button] = true
	GAME:AddDebugID("ms","M "..button, 0.2, Color(0,255,0))
end

function love.mousereleased(x, y, button, istouch)
	if not mousestack[k] then return end --if already released
	GAME:CallHook("MouseReleased",x,y,button,istouch)
	mousestack[button] = nil
	GAME:AddDebugID("ms","M "..button, 0.2, Color(255,200,0))
end

function love.keypressed( key, scancode, isrepeat )
	GAME:CallHook("KeyPressed",key,scancode,isrepeat)
	GAME:AddDebugID("key","K "..key.." "..scancode.." "..tostring(isrepeat), 0.2, Color(0,255,0))
end

function love.keyreleased( key, scancode )
	GAME:CallHook("KeyReleased",key,scancode)
	GAME:AddDebugID("key","K "..key, 0.2, Color(255,200,0))
end

function love.wheelmoved(x, y)
    GAME:CallHook("MouseWheeled",y,x) --swapped since x (<->) mousewheels are like unicorns only dark creatures like voldemort get to see them :v
end

do
	--[[local tr = setmetatable({	--#utf-8 maybe l8r
		["z"] = "y",
		["Z"] = "Y",
		["y"] = "z",
		["Y"] = "Z",
	},{__index = function(x) return x end})]]

	function love.textinput(t)
		--if GAME.handleText <= 0 then return end
		GAME:CallHook("TextInput",t)
	end
end