--[[SirRanjid 2020 https://github.com/SirRanjid]]

local StackP = UIClass("StackP",UI.Base) --menu switching base-panel
UI.StackP = StackP

local stack = setmetatable({},{__newindex = function(t,k,v)
	--if not v.is_a[StackP] then return end
	rawset(t,k,v)
	checkstack()
end})

local pnls = {}

function StackP:init()
	self:Close()
	--self.snd_play
	self.snd_playing = false
	table.insert(pnls,self)
end

function StackP:NewRes(w,h)
	self.w = w
	self.h = h
end

function StackP:SetSoundLoop(snd)
	if type(snd) == "string" then
		if GAME.Sounds[snd] then
			self.snd = {GAME.Sounds[snd]}
		end
	elseif type(snd) == "table" then
		if snd[1] and snd[1].play then
			self.snd = snd
		elseif type(snd[1]) == "string" then
			local cci = 0
			self.snd = {}
			for i,v in ipairs(snd) do
				if GAME.Sounds[v] then
					cci = cci+1
					self.snd[i] = GAME.Sounds[v]
				end
			end
			if #self.snd == 0 then self.snd = nil end
		end
	else
		self.snd = nil
	end
end

GAME:AddHook("KeyPressed","StackP_KP",function(k,s,r)
	
	local ActivePNL = stack[#stack]
	if ActivePNL then
		ActivePNL:KeyPressed(k,s,r)
	end
	
end)

GAME:AddHook("KeyReleased","StackP_KR",function(k,s,r)
	
	local ActivePNL = stack[#stack]
	if ActivePNL then
		ActivePNL:KeyReleased(k,s,r)
	end
	
end)

local function checkstack()
	local sc = #stack
	for i = 1,sc do
		local v = stack[i]
		if i == sc then 
			v:MoveToTop()
			v:SetVisible(true)
			if v.snd then
				if not v.snd_playing then v:StartSound() end
				--[[if stack[i-1] and stack[i-1].snd then
					stack[i-1]:StopSound()
				end]]
			end
		else v:SetVisible(false) end
	end
end

local function removefromstack(pnl)
	for i,v in ipairs(stack) do
		if stack[i] == pnl then table.remove(stack,i) end
	end
	pnl:SetVisible(false)
	checkstack()
end

local function addtostack(pnl)
	removefromstack(pnl)
	table.insert(stack,pnl)
	checkstack()
end

function StackP:StopSound()
	if self.snd_playing then
		--self.snd_play[1]:stop()
		GAME:StopSound("Music")
		self.snd_playing = false
	end
end

function StackP:StartSound()
	if self.snd and type(self.snd) == "table" then

		local do_music
		
		do_music = function()
			--[[if self.snd_play and GAME:ChannelActive("Music") then
				GAME:StopSound("Music")
				--self.snd_play[1]:stop()
			end]]
		
			local c_snd = #self.snd
			if c_snd > 1 then
				for I = 1, 5 do	--try 5 times to get a new track
					local new_snd = self.snd[math.random(1,c_snd)]
					if new_snd ~= self.snd_play then
						self.snd_play = new_snd
						break
					end
				end
			else
				self.snd_play = self.snd[1]
			end
			
			GAME:PlaySound("Music",self.snd_play,do_music)
			
			--self.snd_play[1]:play()
			self.snd_playing = true
			--GAME:Timer(self,self.snd_play[2]:getDuration(),do_music)
		end
		do_music()
	end
end

function StackP:OnClosed(...) end
function StackP:OnOpened(...) end

function StackP:Close(...)
	removefromstack(self)
	self:OnClosed(...)
	--self:StopSound()
end

function StackP:Open(...)
	addtostack(self)
	self:OnOpened(...)
end

function StackP:KeyPressed(k,s,r)
	if k == "escape" then self:Close() end
end

function StackP:KeyReleased(k,s,r)
	
end


GAME:AddHook("SkinChanged","NewSkinB",function(skn) --change all buttons and sliders font
	--local act_skin = GAME:GetActiveSkin()
	local menu_font = GAME:GetSkinFont("menu")
	local changeskin
	
	changeskin = function(tbl)
		for i,v in ipairs(tbl) do
			
			if v.SetFont and not v.is_a["TextEdit"] then -- or v.is_a["Slider"] then
			--if v.SetFont then
				v:SetFont(menu_font)
			end
			
			if v:HasChildren() then
				changeskin(v.Children)
			end
		end
	end
	changeskin(pnls)
end)


GAME:AddHook("cheats","takethis",function()
	local CurTime,sin,cos = CurTime, math.sin, math.cos
	local fuckedupproperly
	
	fuckedupproperly = function(tbl)
		for i,v in ipairs(tbl) do
			local rnd,rnd2 = math.random(), math.random(0,360)*math.pi/180
			
			function v:PostLayout(x,y,w,h,r,rx,ry)
				r = r + rnd2 + CurTime() * rnd
				rx = x + w/(math.sin(CurTime()*rnd+rnd2)/2+1.5)
				ry = y + h/(math.cos(CurTime()*rnd+rnd2)/2+1.5)
				return x,y,w,h,r,rx,ry
			end
			
			if v:HasChildren() then
				fuckedupproperly(v.Children)
			end
		end
	end
	fuckedupproperly(pnls)
end)

